% read wave
[s1 fs] = wavread('aiueo.wav');
[s2 fs] = wavread('kakikukeko.wav');

n_len1 = length(s1);
n_len2 = length(s2);
n_len = max([n_len1, n_len2]);

S = transpose([[s1;zeros(n_len-n_len1,1)], [s2;zeros(n_len-n_len2,1)]]);
S = S + 1.0E-6 * randn(2, n_len);

% create observation
A = [0.65, 0.55; -0.25, 0.72];
X = A * S;
figure(1); plot(X(1,:), X(2,:), '.'); title('Observation');
wavwrite(transpose(X), fs, 'obs.wav');


% pre-whitening
G = whitening(X);
figure(2); plot(G(1,:), G(2,:), '.'); title('After whitening');

% blind source separation
Y = ICA(G);
figure(3); plot(Y(1,:), Y(2,:), '.'); title('After ICA');

% write wave
wavwrite(Y(1,:)*0.5./max(abs(Y(1,:))), fs, 'ica-1.wav');
wavwrite(Y(2,:)*0.5./max(abs(Y(2,:))), fs, 'ica-2.wav');
