function [y, V] = whitening(x)
% [y, V] = whitening(x)
%
% Applies pre-whitening to mixed real or complex signals. 
%
% Inputs
% ------
%    x: channe x length
%
% Outputs
% ------
%    y: separated data
%    V: whitening matrix
% 
%
[n_ch n_len] = size(x);

[E d] = eigs(x * x' ./ n_len);
V = E * inv(sqrt(d)) * E';
y = V * x;
